#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MALA "abcdefghijklmnopqrstuvwxyz"
#define VELKA "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
#define CISLA "0123456789"
#define SPECIAL "-_=+[]{}()<>/*"

int main(int argc, char *argv[])
{
 char chars[256]="", a;
 int i,j,delka = 8,nchars;
 FILE *f;
 
 if (argc < 2) {
  fputs("Aspon 1 parametr\nheslo -mvsch [<pocet znaku>]\n",stderr);
  return -1;
 }
 
 for (i=1; i<argc; i++) {
  if (atol(argv[i]) != 0) {
   /* Pocet znaku */
   delka = atol(argv[i]);
  } else if (argv[i][0] == '-') {
   /* Parametr */
   for (j=1; j<strlen(argv[i]); j++) {
    switch (argv[i][j]) {
     case 'm':
      strcat(chars,MALA);
      break;
     case 'v':
      strcat(chars,VELKA);
      break;
     case 'c':
      strcat(chars,CISLA);
      break;
     case 's':
      strcat(chars,SPECIAL);
      break;
     case 'h':
      fputs("-m - mala pismena\n-v - velka pismena\n-c - cisla\n-s - specialni znaky\n",stderr);
      return -1;
      break;
     default:
      fputs("-h for help\n",stderr);
      return -1;
    }
   }
  }
 }
 if (delka < 0) {
  fputs("Zaporna delka\n",stderr);
  return -1;
 }
 nchars = strlen(chars);
 if (nchars == 0) {
  fputs("Nezadal si sadu znaku\n",stderr);
  return -1;
 }
 f = fopen("/dev/random","r");
 if (!f) {
  fputs("Nejde otevrit /dev/random\n",stderr);
  return -1;
 }
 
 for (i=0;i<delka;i++) {
  a = fgetc(f);
  a = chars[((unsigned char)a) % nchars];
   /* Vybere z pole nahodny prvek podle a */
  fwrite(&a,1,1,stdout);
  fflush(stdout);
 }
 puts("");
 fclose(f);
 return 0;
}
